Subject: Re: BUG: soft lockup detected on CPU#0! (2.6.18.2 plus hacks)

From: Ben Greear <[email-masked]>
Date: Mon, 08 Jan 2007 08:57:10 -0800

Jarek Poplawski wrote:
> On Fri, Jan 05, 2007 at 12:33:43PM -0800, Ben Greear wrote:
> ...
>   
>> So, I do believe this was the problem we were hitting, and it seems fixed.
>>     
>
> Congratulations!
>
> But I can see one strange thing in vlan.c:
>
> /* Must be invoked with RCU read lock (no preempt) */
> static struct vlan_group *__vlan_find_group(int real_dev_ifindex)
> ...
>  * Must be invoked with RCU read lock (no preempt)
>  */
> struct net_device *__find_vlan_dev(struct net_device *real_dev,
> ...
>
> But later in this file no sign of disabling preemption
> for these calls and for hlist_add_head_rcu and hlist_del_rcu.
>
> I can't imagine how this works?
>   
Perhaps...I didn't RCU-ify VLANs, but I can take a look.

For the record, the soft lockup was using MAC-VLANs, not 802.1Q VLANs, 
so it wouldn't
have been affected by bugs in VLANs one way or the other.

Ben

> Jarek P. 

-- 
Ben Greear <[email-masked]> 
Candela Technologies Inc  http://www.candelatech.com